<div class="container">
  <div class="w-100 l-main mt-4">
    <div class="row header-upper-row">
      <div class="header-text col-lg-4">
        {{viewGetFullName()}}
      </div>
      <div class="col-lg-8">
        <div class="row">
          <span class="text-secondary pr-2"> {{currentDate}} </span>
          <span> Works for Today </span>
        </div>
        <div *ngIf="!headerTasksInfoLoaded" class="row">
          <div class="lds-dual-ring m-0"></div>
        </div>
        <div *ngIf="headerTasksInfoLoaded" class="row h-100">
          <div class="col-lg-4 header-item">
            <span>All My tasks</span>
            <h3>{{totalTasks.data.length}}</h3>
          </div>
          <div class="col-lg-4 header-item">
            <span>Tasks for Today</span>
            <h3>{{tasksForTodayCount}}</h3>
          </div>
          <div class="col-lg-4 header-item">
            <span>My projects</span>
            <h3>{{myProjectsCount}}</h3>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div class="row mt-4">
    <div *ngIf="!memberInfoLoaded" class="lds-dual-ring col-lg-4 l-main mt-0"></div>
    <div *ngIf="memberInfoLoaded" class="col-lg-4 l-main">
      <div class="l-image mt-5 mb-5">
        <img class="l-image" src="data:image/PNG;base64,{{memberInfo.image}}">
      </div>
      <div class="avatar-upload-container">
        <button mat-button class="btn-upload" (click)="openDialog(avatarUpload)">
          Change avatar
        </button>
      </div>
      <div class="l-member-info-label">
        Member Info
      </div>
      <div class="mt-3 mb-3">
        <div class="row">
          <div class="col-lg-5 font-weight-bold">
            First Name
          </div>
          <div class="col-lg-7">
            {{memberInfo.firstName}}
          </div>
        </div>
        <div class="row">
          <div class="col-lg-5 font-weight-bold">
            Last Name
          </div>
          <div class="col-lg-7">
            {{viewGetLastName()}}
          </div>
        </div>
        <div class="row">
          <div class="col-lg-5 font-weight-bold">
            Email
          </div>
          <div class="col-lg-7 text-break">
            {{memberInfo.email}}
          </div>
        </div>
        <div class="row">
          <div class="col-lg-5 font-weight-bold">
            Role
          </div>
          <div class="col-lg-7">
            {{memberInfo.role.roleName}}
          </div>
        </div>
      </div>
    </div>
    <div class="col-lg-8 r-main">
      <div class="row">
        <mat-tab-group class="w-100" (selectedTabChange)="cancelEditCell()">
          <mat-tab label="Total Tasks">
            <div *ngIf="!totalTasksLoaded" class="lds-dual-ring mt-0"></div>
            <div [hidden]="!totalTasksLoaded" class="mat-elevation-z8 table-container">
              <table class="w-100" mat-table [dataSource]="totalTasks" matSort #sortTotal="matSort">

                <ng-container matColumnDef="projectName">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Project Name </th>
                  <td mat-cell *matCellDef="let row"> {{row.project.projectName}} </td>
                </ng-container>

                <ng-container matColumnDef="taskName">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Task Name </th>
                  <td mat-cell *matCellDef="let row"> {{row.taskName}} </td>
                </ng-container>

                <ng-container matColumnDef="dateStart">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Start Date </th>
                  <td mat-cell *matCellDef="let row"> {{row.dateStart}} </td>
                </ng-container>

                <ng-container matColumnDef="pert">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Hours </th>
                  <td mat-cell *matCellDef="let row"> {{row.pert}} </td>
                </ng-container>

                <ng-container matColumnDef="completed">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Completed %</th>
                  <td mat-cell [ngClass]="{'cell-edit-mode': i===currentRowIndex}" *matCellDef="let row; let i = index">
                    <div class="cursor-pointer" *ngIf="i!==currentRowIndex" (dblclick)="doubleClick(i, row.taskId)">
                      {{row.completed}}
                    </div>
                    <div *ngIf="i===currentRowIndex">
                      <mat-slider thumbLabel [displayWith]="formatLabel" #editData tickInterval="1"
                        [value]="currentPercentValue" min="0" max="100">
                      </mat-slider>
                      <button mat-icon-button (click)="saveEditCell(row.taskId,editData.value)">
                        <mat-icon> done </mat-icon>
                      </button>
                      <button (click)="cancelEditCell()" mat-icon-button>
                        <mat-icon> clear </mat-icon>
                      </button>
                    </div>
                  </td>
                </ng-container>

                <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
                <tr mat-row *matRowDef="let row; columns: displayedColumns;">
                </tr>
              </table>

              <mat-paginator [pageSizeOptions]="[20]"></mat-paginator>
            </div>
          </mat-tab>
          <mat-tab label="New Tasks">
            <div *ngIf="!newTasksLoaded" class="lds-dual-ring mt-0"></div>
            <div [hidden]="!newTasksLoaded" class="mat-elevation-z8">
              <table class="w-100" mat-table [dataSource]="newTasks" matSort #sortNew="matSort">

                <ng-container matColumnDef="projectName">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Project Name </th>
                  <td mat-cell *matCellDef="let row"> {{row.project.projectName}} </td>
                </ng-container>

                <ng-container matColumnDef="taskName">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Task Name </th>
                  <td mat-cell *matCellDef="let row"> {{row.taskName}} </td>
                </ng-container>

                <ng-container matColumnDef="dateStart">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Start Date </th>
                  <td mat-cell *matCellDef="let row"> {{row.dateStart}} </td>
                </ng-container>

                <ng-container matColumnDef="pert">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Hours </th>
                  <td mat-cell *matCellDef="let row"> {{row.pert}} </td>
                </ng-container>

                <ng-container matColumnDef="completed">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Completed %</th>
                  <td mat-cell [ngClass]="{'cell-edit-mode': i===currentRowIndex}" *matCellDef="let row; let i = index">
                    <div class="cursor-pointer" *ngIf="i!==currentRowIndex" (dblclick)="doubleClick(i, row.taskId)">
                      {{row.completed}}
                    </div>
                    <div *ngIf="i===currentRowIndex">
                      <mat-slider thumbLabel [displayWith]="formatLabel" #editData tickInterval="1"
                        [value]="currentPercentValue" min="0" max="100">
                      </mat-slider>
                      <button mat-icon-button (click)="saveEditCell(row.taskId,editData.value)">
                        <mat-icon> done </mat-icon>
                      </button>
                      <button (click)="cancelEditCell()" mat-icon-button>
                        <mat-icon> clear </mat-icon>
                      </button>
                    </div>
                  </td>
                </ng-container>

                <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
                <tr mat-row *matRowDef="let row; columns: displayedColumns;">
                </tr>
              </table>
            </div>
          </mat-tab>

          <mat-tab label="Tasks in Progress">
            <div *ngIf="!tasksInProgressLoaded" class="lds-dual-ring mt-0"></div>
            <div [hidden]="!tasksInProgressLoaded" class="mat-elevation-z8">
              <table class="w-100" mat-table [dataSource]="tasksInProgress" matSort #sortProgress="matSort">

                <ng-container matColumnDef="projectName">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Project Name </th>
                  <td mat-cell *matCellDef="let row"> {{row.project.projectName}} </td>
                </ng-container>

                <ng-container matColumnDef="taskName">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Task Name </th>
                  <td mat-cell *matCellDef="let row"> {{row.taskName}} </td>
                </ng-container>

                <ng-container matColumnDef="dateStart">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Start Date </th>
                  <td mat-cell *matCellDef="let row"> {{row.dateStart}} </td>
                </ng-container>

                <ng-container matColumnDef="pert">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Hours </th>
                  <td mat-cell *matCellDef="let row"> {{row.pert}} </td>
                </ng-container>

                <ng-container matColumnDef="completed">
                  <th mat-header-cell *matHeaderCellDef mat-sort-header> Completed %</th>
                  <td mat-cell [ngClass]="{'cell-edit-mode': i===currentRowIndex}" *matCellDef="let row; let i = index">
                    <div class="cursor-pointer" *ngIf="i!==currentRowIndex" (dblclick)="doubleClick(i, row.taskId)">
                      {{row.completed}}
                    </div>
                    <div *ngIf="i===currentRowIndex">
                      <mat-slider thumbLabel [displayWith]="formatLabel" #editData tickInterval="1"
                        [value]="currentPercentValue" min="0" max="100">
                      </mat-slider>
                      <button mat-icon-button (click)="saveEditCell(row.taskId,editData.value)">
                        <mat-icon> done </mat-icon>
                      </button>
                      <button (click)="cancelEditCell()" mat-icon-button>
                        <mat-icon> clear </mat-icon>
                      </button>
                    </div>
                  </td>
                </ng-container>

                <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
                <tr mat-row *matRowDef="let row; columns: displayedColumns;">
                </tr>
              </table>
            </div>
          </mat-tab>
        </mat-tab-group>
      </div>
    </div>
  </div>
</div>

<ng-template #avatarUpload>
  <h1 mat-dialog-title>Avatar Upload</h1>
  <div mat-dialog-content>
    <image-cropper [imageChangedEvent]="imageChangedEvent" [maintainAspectRatio]="true" [aspectRatio]="4 / 4"
      [resizeToWidth]="256" format="png" (imageCropped)="imageCropped($event)"></image-cropper>
    <img [src]="croppedImage" />
  </div>
  <div mat-dialog-footer>
    <input type="file" id="file" accept="image/*" class="inputfile" (change)="myUploader($event)">
    <label for="file" class="mt-4">Choose a file</label>
    <button *ngIf="imageChangedEvent" mat-button class="btn-upload" (click)="uploadCroppedImage()"> Upload </button>
  </div>
</ng-template>